files up to grail.hh




/*** Boolean automata, Z or field automata  ***/


//are-equivalent.hh
template <typename Aut1, typename Aut2>
bool are_equivalent(const Aut1& a1, const Aut2& a2);

/***  Boolean automata   ***/


//are-equivalent.hh
template <typename Lhs, typename Rhs>
typename Lhs::element_type::automaton_nocv_t
difference(const Lhs& lhs, const Rhs& rhs);

//complement.hh
template <typename Aut>
void
complement_here(Aut& aut);

//complement.hh
template <typename Aut>
auto
complement(const Aut& aut, bool history=true)
  -> decltype(copy(aut));



//determinize.cc
template <typename Aut,
	  typename Context = context_t_of<Aut>>
  auto
  determinize(const Aut& a, bool keep_history = true)
  -> mutable_automaton<Context>;

//determinize.cc
template <typename Aut>
auto
codeterminize(const Aut& a, bool keep_history = true)
  -> Aut;




/*** automaton over letters ***/

//complete.hh
template <typename Aut>
Aut&
complete_here(Aut& aut);

//complete.hh
template <typename Aut>
auto
complete(const Aut& aut, bool history=true)
  -> decltype(sttc::copy(aut));


//determinize.hh
template <typename Aut>
determinize_weighted(const Aut& a)
  -> Aut;

//enumerate.hh
template <typename Automaton>
typename internal::enumerater<Automaton>::polynomial_t
enumerate(const Automaton& aut, unsigned max);

//enumerate.hh
template <typename Automaton>
typename internal::enumerater<Automaton>::polynomial_t
shortest(const Automaton& aut, unsigned num);

//eval.hh

template <typename Aut>
auto
eval(const Aut& a, const typename labelset_t_of<Aut>::word_t& w)
  -> weight_t_of<Aut>;


/*** standard automata ***/

//concatenate.hh
template <typename A, typename B>
A&
concatenate_here(A& res, const B& b);

//concatenate.hh
template <typename A, typename B>
auto
concatenate(const A& lhs, const B& rhs)
  -> decltype(join_automata(lhs, rhs));

//concatenate.hh
template <typename Aut>
Aut
chain(const Aut& aut, int min, int max);



/*** transducers ***/

//compose.hh
template <size_t I, size_t J, typename Lhs, typename Rhs>
auto
composeIJ(Lhs& lhs, Rhs& rhs, bool history=true);

//compose.hh
template <typename Lhs, typename Rhs>
auto
compose(const Lhs& lhs, const Rhs& rhs, bool history=true);

//compose.hh
template <typename Aut, typename Tdc>
auto
eval(const Aut& aut, const Tdc& tdc)
  -> decltype(projection<1>(tdc));




/*** Any automaton ***/


//accessible.hh
template <typename Set, typename Aut>
void
fill_with_accessible_states(Set& res, const Aut& aut, bool include_pre_post=false);

//accessible.hh
template <typename Aut>
std::set<state_t>
accessible_states(const Aut& aut, bool include_pre_post=false);

//accessible.hh
template <typename Set, typename Aut>
void
fill_with_coaccessible_states(Set& res, const Aut& aut, bool include_pre_post=false);

//accessible.hh
template <typename Aut>
std::set<state_t>
coaccessible_states(const Aut& aut, bool include_pre_post=false);

//accessible.hh
template <typename Aut>
std::set<state_t>
useful_states(const Aut& aut, bool include_pre_post=false);

//accessible.hh
template <typename Aut>
size_t
num_accessible_states(const Aut& aut);

//accessible.hh
template <typename Aut>
size_t
num_coaccessible_states(const Aut& aut);

//accessible.hh
template <typename Aut>
size_t
num_useful_states(const Aut& aut);

//accessible.hh
template <typename Aut>
typename Aut::element_type::automaton_nocv_t
accessible(const Aut& aut, bool history=true);

//accessible.hh
template <typename Aut>
void
accessible_here(Aut& aut);

//accessible.hh
template <typename Aut>
typename Aut::element_type::automaton_nocv_t
coaccessible(const Aut& aut, bool history=true);

//accessible.hh
template <typename Aut>
void
coaccessible_here(Aut& aut);
  
//accessible.hh
template <typename Aut>
typename Aut::element_type::automaton_nocv_t
trim(const Aut& aut, bool history=true);

//accessible.hh
template <typename Aut>
void
trim_here(Aut& aut);

//accessible.hh
template <typename Aut>
bool is_trim(const Aut& aut);

//accessible.hh
template <typename Aut>
bool is_useless(const Aut& aut);

//accessible.hh
template <typename Aut>
bool is_accessible(const Aut& aut);

//accessible.hh
template <typename Aut>
bool is_coaccessible(const Aut& aut);

//accessible.hh
template <typename Aut>
bool is_empty(const Aut& aut);

//accessible.hh
template <typename Aut>
bool is_empty(const Aut& aut);

//are-isomorphic.hh
template <typename Aut1, typename Aut2>
bool
are_isomorphic(const Aut1& a1, const Aut2& a2);

//copy.hh
template <typename AutIn, typename AutOut, typename Pred>
void
copy_into(const AutIn& in, AutOut& out, Pred keep_state, bool history=true);

//copy.hh
template <typename AutIn, typename AutOut>
void
copy_into(const AutIn& in, AutOut& out, bool history=true);

//copy.hh
template <typename AutIn, typename AutOut, typename Pred>
void
copy_support(const AutIn& in, AutOut& out, Pred keep_state, bool history=true);

//copy.hh
template <typename AutIn, typename AutOut>
void
copy_support(const AutIn& in, AutOut& out, bool history=true);
  
//copy.hh
  template <typename AutIn,
            typename AutOut = typename AutIn::element_type::automaton_nocv_t,
            typename Pred>
  AutOut
  copy(const AutIn& input, Pred keep_state, bool history=true);

//copy.hh
template <typename AutIn,
	  typename AutOut = typename AutIn::element_type::automaton_nocv_t>
AutOut
copy(const AutIn& input, bool history=true);

//copy.hh
template <typename AutIn,
            typename AutOut = typename AutIn::element_type::automaton_nocv_t>
  AutOut
copy(const AutIn& input, const std::set<state_t>& keep, bool history=true);

//distance.hh
template<typename Aut>
  std::vector<transition_t>
  path_bfs(const Aut& aut, state_t start,
	   state_t end);

//distance.hh
template<typename Aut>
std::unordered_map<state_t,
		   std::pair<unsigned,
			     transition_t>>
  paths_ibfs(const Aut& aut, std::vector<state_t> start);

//factor.hh
  template <typename Aut>
  void
  prefix_here(Aut& a);

//factor.hh
template <typename Aut>
typename Aut::element_type::automaton_nocv_t
prefix(const Aut& a);

//factor.hh
template <typename Aut>
void
suffix_here(Aut& a);

//factor.hh
template <typename Aut>
typename Aut::element_type::automaton_nocv_t
suffix(const Aut& a);

//factor.hh
template <typename Aut>
void
factor_here(Aut& a);

//factor.hh
template <typename Aut>
typename Aut::element_type::automaton_nocv_t
factor(const Aut& a);

//aut-to-exp.hh
template <typename Aut,
	  typename Context = ratexpset_of<context_t_of<Aut>>>
  typename Context::ratexp_t
  aut_to_exp(const Aut& a,
             const state_chooser_t<Aut>& next_state);

//aut-to-exp.hh
template <typename Aut,
	  typename Context = ratexpset_of<context_t_of<Aut>>>
  typename Context::ratexp_t
  aut_to_exp_naive(const Aut& a);





/*** Output ***/

//daut.hh
template <typename Aut>
std::ostream&
daut(const Aut& aut, std::ostream& out);

//dot.hh
template <typename Aut>
std::ostream&
dot(const Aut& aut, std::ostream& out, bool dot2tex = false, bool history = false, bool horizontal = true);

//fsm.hh
template <typename Aut>
std::ostream&
efsm(const Aut& aut, std::ostream& out);

//grail.hh
template <typename Aut>
std::ostream&
fado(const Aut& aut, std::ostream& out);

//grail.hh
template <typename Aut>
std::ostream&
grail(const Aut& aut, std::ostream& out);




/*** Rational expressions ***/


//concatenate.hh
template <typename ValueSet>
typename ValueSet::value_t
concatenate(const ValueSet& vs,
	    const typename ValueSet::value_t& lhs,
	    const typename ValueSet::value_t& rhs);

//concatenate.hh
template <typename RatExpSet>
typename RatExpSet::ratexp_t
chain(const RatExpSet& rs, const typename RatExpSet::ratexp_t& r,
      int min, int max);

//concatenate.hh
template <typename ValueSet>
typename ValueSet::value_t
multiply(const ValueSet& vs,
	 const typename ValueSet::value_t& lhs,
	 const typename ValueSet::value_t& rhs);

//constant-term.hh
template <typename RatExpSet>
weight_t_of<RatExpSet>
constant_term(const RatExpSet& rs, const typename RatExpSet::ratexp_t& e);

//derivation.hh
  template <typename RatExpSet>
  rat::ratexp_polynomial_t<RatExpSet>
  derivation(const RatExpSet& rs,
             const typename RatExpSet::ratexp_t& e,
             label_t_of<RatExpSet> a,
             bool breaking = false);

//derivation.hh
template <typename RatExpSet>
rat::ratexp_polynomial_t<RatExpSet>
derivation(const RatExpSet& rs,
	   const rat::ratexp_polynomial_t<RatExpSet>& p,
	   label_t_of<RatExpSet> a,
	   bool breaking = false);

//derivation.hh
template <typename RatExpSet>
rat::ratexp_polynomial_t<RatExpSet>
derivation(const RatExpSet& rs,
	   const typename RatExpSet::ratexp_t& e,
	   const typename RatExpSet::labelset_t::word_t& l,
	   bool breaking = false);

//derivation.hh
template <typename RatExpSet>
mutable_automaton<typename RatExpSet::context_t>
derived_term(const RatExpSet& rs, const typename RatExpSet::ratexp_t& r,
	     bool breaking = false, bool keep_history = true);

//draw_exp.hh
template <typename Ratexp,
	  typename Context>
mutable_automaton<context<ctx::law_char, b>>
  draw_exp(const Context& ctx, const Ratexp& e);

//exp_parser.hh

template <typename RatExpSet>
typename RatExpSet::ratexp_t
parse_exp(const RatExpSet& rs,
	  const std::string& s, bool check_complete=true);

//expand.hh
template <typename RatExpSet>
typename RatExpSet::value_t
expand(const RatExpSet& rs, const typename RatExpSet::value_t& e);
  
