#include<awali/sttc/automaton.hh>
#include<awali/sttc/algos/determinize.hh>
#include<awali/sttc/weightset/z.hh>
#include<awali/sttc/algos/lal-to-law.hh>

using namespace awali;
using namespace awali::sttc;

int main() {
  auto aut=make_automaton<z>({'a'});
  state_t i=aut->add_state();
  state_t f=aut->add_state();
  aut->set_transition(i,i,'a');
  aut->set_transition(i,f,'a');
  aut->set_transition(f,i,'a',-1);
  aut->set_initial(i);
  aut->set_final(f);

  auto det = determinize_weighted(aut);
  js_print(det, std::cout) << std::endl;

  state_t x=aut->add_state();
  aut->set_transition(i,x,'a');
  aut->set_transition(x,f,'b');

  auto law = lal_to_law(aut);
  compact_law(law);
  js_print(law, std::cout) << std::endl;
}


  
